--[[   ShaderMod by Shader 
	  	60 Rogue, Blackhand, http://www.angelicwrath.com
     Adobted from CritCombo By Kuipo
]]--

SHADERMOD_VERSION = "v2.0";
---------------------------------------
---Current Combo Colors------
DISPLAY_RED = ".55";	
DISPLAY_GREEN = ".55";
DISPLAY_BLUE = ".5"; 
---------------------------------------
---------------------------------------
---Finished Combo Colors-----
FDISPLAY_RED = ".7";	
FDISPLAY_GREEN = ".1";
FDISPLAY_BLUE = ".1"; 
---------------------------------------
-- Function: 		SMOnLoad()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		General OnLoad function
function SMOnLoad()
	--Register Events
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("UNIT_COMBO_POINTS");

	--Variables used to parse variables from CHAT_MSG events

	COMBAT_HIT = "You hit (.+) for (%d+)."; 
	COMBAT_CRIT	= "You crit (.+) for (%d+)."; 
			
	SPELL_HIT = "Your (.+) hits (.+) for (%d+)."; 
	SPELL_CRIT = "Your (.+) crits (.+) for (%d+)."; 

	--Misc Variables used to compare to records
	CritDmg = 0;
	CritCombo = 0;
	CritComboDmg = 0;
	CurrentSpell = 0;
		
	DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] .:Loaded:. For configuration type:  /sm options", .2, .0);
	--PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\intro.wav");
	
	--Get Player Name and Current Realm so Options can be saved per character
	SMPlayerRealm = GetCVar("realmName");
	SMPlayerName = UnitName("player");	
	
	--MyAddons Support for options frame
	UIPanelWindows["ShaderModOptionsFrame"] = {area = "center", pushable = 0};
end


-- Function: 		SMInitialize()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Register Slash Commands and calls SMInitializeSMData to initialize SMData incase it isn't already in SavedVariables
function SMInitialize()
	SlashCmdList["CritCombo"] = SMCommand;
	SLASH_CritCombo1 = "/ShaderMod";
	SLASH_CritCombo2 = "/ShaderM";
	SLASH_CritCombo3 = "/sm"
	
	SMInitializeSMData();
end


-- Function: 		SMCommand()
-- Arguments:		msg == whatever is typed after a slash command (Example: show)
-- Returns:  		None
-- Used for: 		Handles all the slash commands
function SMCommand(msg)
	if (string.lower(msg) == "records") then
		DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] " .. SHADERMOD_VERSION .. " - Modification of CritCombo by Kuipo.", .2, .0);
		DEFAULT_CHAT_FRAME:AddMessage("--- Hits Based Record ---", .65, .65, .6);
		DEFAULT_CHAT_FRAME:AddMessage("*" .. SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo .. "* crits for *" .. SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg .. "* damage. ");
		DEFAULT_CHAT_FRAME:AddMessage("--- Damage Based Record ---", .65, .65, .6);
		DEFAULT_CHAT_FRAME:AddMessage("*" .. SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo .. "* crits for *" .. SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg .. "* damage. ");
		return;
	end
	
	if (string.lower(msg) == "help") then
		SMDisplayHelp();
		return;
	end
	
	if (string.lower(msg) == "menu") then
		PlaySound("igMainMenuOpen");
		ShowUIPanel(ShaderModOptionsFrame);
	  return;
	end

	if (string.lower(msg) == "options") then
		PlaySound("igMainMenuOpen");
		ShowUIPanel(ShaderModOptionsFrame);
	  return;
	end

	if (string.lower(msg) == "version") then
		DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] Current Version: " .. SHADERMOD_VERSION, .2, .0);
	  return;
	end
	
	if (string.lower(msg) == "resetconfig") then
		SMSetDefaultOptions();
		DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] Configuration Reset.", .2, .0);
	  return;
	end
	
	--Handle Everything else
	SMDisplayHelp();
end


-- Function: 		SMOnEvent()
-- Arguments:		event == event action that is triggered
--              arg1 == argument sent by the event if applicable
-- Returns:  		None
-- Used for: 		General Event handler function
function SMOnEvent(event, arg1)
	--Call SMInitialize() after variables have been loaded from SavedVariables
	if (event == "VARIABLES_LOADED") then 
		SMInitialize(); 
		
		-- MyAddon's Support
		if(myAddOnsFrame) then
			myAddOnsList.CritCombo = { name = "ShaderMod",
						description = "Displays crit combos of Backstab, Eviscerate, and Sinister Strike.  Intended for Imp. Backstab rogues.",
						version = SHADERMOD_VERSION,
						category = MYADDONS_CATEGORY_COMBAT,
						optionsframe = "ShaderModOptionsFrame"
					};
		end
	end
	
-- CHECKING FOR HITS / CRITS
	if (event == "CHAT_MSG_SPELL_SELF_DAMAGE") then
		CurrentSpell = 0;
		--HIT--
		for spellname, creaturename, damage in string.gfind(arg1, SPELL_HIT)do
		CurrentSpell = tostring(spellname);
		--DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] Current String CurrentSpell: ->" .. CurrentSpell .. "<-", .2, .0);
			if((CurrentSpell == "Sinister Strike") or (CurrentSpell == "Backstab") or (CurrentSpell == "Eviscerate") or (CurrentSpell == "Auto Shot") or (CurrentSpell == "Arcane Shot") or (CurrentSpell == "Aimed Shot") or (CurrentSpell == "Mortal Strike") or (CurrentSpell == "Heroic Strike") or (CurrentSpell == "Execute") or (CurrentSpell == "Pounce") or (CurrentSpell == "Rake") or (CurrentSpell == "Claw") or (CurrentSpell == "Shred") or (CurrentSpell == "Ravage") or (CurrentSpell == "Ferocious Bite") or (CurrentSpell == "Overpower") or (CurrentSpell == "Ambush") or (CurrentSpell == "Bloodthirst") or (CurrentSpell == "Hemorrhage") or (CurrentSpell == "Ghostly Stike") or (CurrentSpell == "Riposte"))then
					--Check for 5 combo points // play "finishhim.wav"
					if ((SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Small == true) and (GetComboPoints("Player") == 5)) then
						PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\finishhim.wav");
					end
					if (CritCombo ~= 0) then
						SMCompare_Combos();
					end
			end
		end
		--CRIT--
		for spellname, creaturename, damage in string.gfind(arg1, SPELL_CRIT)do
		CurrentSpell = tostring(spellname);
		--DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] Current String CurrentSpell: ->" .. CurrentSpell .. "<-", .2, .0);
			if((CurrentSpell == "Sinister Strike") or (CurrentSpell == "Backstab") or (CurrentSpell == "Eviscerate") or (CurrentSpell == "Auto Shot") or (CurrentSpell == "Arcane Shot") or (CurrentSpell == "Aimed Shot") or (CurrentSpell == "Mortal Strike") or (CurrentSpell == "Heroic Strike") or (CurrentSpell == "Execute") or (CurrentSpell == "Pounce") or (CurrentSpell == "Rake") or (CurrentSpell == "Claw") or (CurrentSpell == "Shred") or (CurrentSpell == "Ravage") or (CurrentSpell == "Ferocious Bite") or (CurrentSpell == "Cleave") or (CurrentSpell == "Multi-Shot") or (CurrentSpell == "Whirlwind") or (CurrentSpell == "Overpower") or (CurrentSpell == "Ambush") or (CurrentSpell == "Bloodthirst") or (CurrentSpell == "Hemorrhage") or (CurrentSpell == "Ghostly Stike") or (CurrentSpell == "Riposte"))then
							
				--Check for 5 combo points // play "finishhim.wav"
				if ((SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Small == true) and (GetComboPoints("Player") == 5)) then
					PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\finishhim.wav");
				end
				CritDmg = tonumber(damage);
				CritCombo = CritCombo + 1;
				CritComboDmg = CritComboDmg + damage;
				if (CritCombo >= 1 and SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == true) then
							if (CritCombo > 2 and CritCombo < 4) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\unstoppable.wav");
								end
								SMMessageFrame:AddMessage("Unstoppable! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 3 and CritCombo < 5) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\DoubleKill.wav");
								end
								SMMessageFrame:AddMessage("Double Kill! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 4 and CritCombo < 6) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\MultiKill.wav");
								end
								SMMessageFrame:AddMessage("Multi Kill! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 5 and CritCombo < 7) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\KillingSpree.wav");
								end
								SMMessageFrame:AddMessage("Killing Spree! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 6 and CritCombo < 8) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Dominating.wav");
								end
								SMMessageFrame:AddMessage("Dominating! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 7 and CritCombo < 10) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Rampage.wav");
								end
								SMMessageFrame:AddMessage("Rampage! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 9 and CritCombo < 12) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\UltraKill.wav");
								end
								SMMessageFrame:AddMessage("Ultra Kill! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 11 and CritCombo < 14) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\GodLike.wav");
								end
								SMMessageFrame:AddMessage("God Like! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 13 and CritCombo < 16) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\WhickedSick.wav");
								end
								SMMessageFrame:AddMessage("Whicked Sick! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 15 and CritCombo < 17) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\HolyShit.wav");
								end
								SMMessageFrame:AddMessage("Holy Shit! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 16 and CritCombo < 19) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\MonsterKill.wav");
								end
								SMMessageFrame:AddMessage("Mm-mmm-mmm Monster Kill! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 18 and CritCombo < 21) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\LudicrousKill.wav");
								end
								SMMessageFrame:AddMessage("Lu-Lu-Lu Ludicrous Kill! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
							if (CritCombo > 22) then
								if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
									PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Ownage.wav");
								end
								SMMessageFrame:AddMessage("Ownnnaaaaaggge! x" .. CritCombo, DISPLAY_RED, DISPLAY_GREEN, DISPLAY_BLUE, 1, 3);
							end
				           end
			         end
		      end	
	 end


	--If player looses agro or kills the current target and SMData[SMPlayerRealm][SMPlayerName].Combos_End_After_Battle is on,
	--  end the combo and compare the combo to the record by calling SMCompare_Combos()
	if (event == "PLAYER_REGEN_ENABLED") then
		if (SMData[SMPlayerRealm][SMPlayerName].Combos_End_After_Battle == true and CritCombo ~= 0) then
			SMCompare_Combos();
		end
	end

end

-- Function: 		SMCompare_Combos()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Used to compare current combo to combo records to see if it beats any of the records.
function SMCompare_Combos()
	--if statement to see if records meets or breaks both records
	extra_crits_toggle = 0;
	if (CritCombo >= SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo and CritComboDmg >= SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg) then
		SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo = CritCombo;
		SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg = CritComboDmg;
		SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo = CritCombo;
		SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg = CritComboDmg;
	else
		--Used to check if current combo has more hits, if it ties the record for hits, checks to see if the damage is higher than the current record for most hits
		if (CritCombo >= SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo) then
			if (CritCombo == SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo) then
				if (CritComboDmg > SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg) then
					SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo = CritCombo;
					SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg = CritComboDmg;
				end
			end
			if (CritCombo > SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo) then
				SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo = CritCombo;
				SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg = CritComboDmg;
			end
		end
		
		--Used to check if the damage done by the combo is higher than the record for damage dealt in a combo,
		--  if it ties the record for damage, then it checks to see how many hits it took and will set the higher number of hits as the record
		if (CritComboDmg >= SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg) then
			if (CritComboDmg == SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg) then
				if (CritCombo > SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo) then
					SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo = CritCombo;
					SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg = CritComboDmg;
				end
			end
			if (CritComboDmg > SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg) then
				SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo = CritCombo;
				SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg = CritComboDmg;
			end
		end
	end
	
	
-- BIG LETTER COMBO DISPLAY**
	if (CritCombo > 2 and CritCombo < 4) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\unstoppable.wav");	
		end		
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Unstoppable!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 3 and CritCombo < 5) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\DoubleKill.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Double Kill!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 4 and CritCombo < 6) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\MultiKill.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Multi Kill!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 5 and CritCombo < 7) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Killing Spree.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Killing Spree!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 6 and CritCombo < 8) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Dominating.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Dominating!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 7 and CritCombo < 10) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Rampage.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Rampage!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 9 and CritCombo < 12) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\UltraKill.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Ultra Kill!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 11 and CritCombo < 14) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\GodLike.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("God Like!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 13 and CritCombo < 16) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\WhickedSick.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Whicked Sick!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 15 and CritCombo < 17) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\HolyShit.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Holy Shit!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 16 and CritCombo < 19) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\MonsterKill.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Mm-mmm MonsterKill!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 18 and CritCombo < 21) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\LudicrousKill.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Lu-Lu-LU Ludicrous Kill!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end
	if (CritCombo > 22) then
		if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display == false and SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big == true) then
			PlaySoundFile("Interface\\AddOns\\ShaderMod\\Sounds\\Ownage.wav");
		end
		SMMessageFrame:AddMessage("Damage: " .. CritComboDmg, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Combo: " .. CritCombo, 1, 1, 1, 1, 3);
		SMMessageFrame:AddMessage("Ownnnaaaaaggge!",FDISPLAY_RED, FDISPLAY_GREEN, FDISPLAY_BLUE, 1, 3);
	end

-- PARTY DISPLAY **
	if (SMData[SMPlayerRealm][SMPlayerName].Party_Display == true) then
             if ((CritCombo > 22)) then
		SendChatMessage("[ShaderMod] Ownnnaaaaaggge!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
         else
               if ((CritCombo > 18 and CritCombo < 21)) then
			SendChatMessage("[ShaderMod] Lu-lu-lu-lu-ludicrous Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
	   else
        	 if ((CritCombo > 16 and CritCombo < 19)) then
				SendChatMessage("[ShaderMod] Mm-Mmm Monster Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
	     else
        	   if ((CritCombo > 15 and CritCombo < 17)) then
				SendChatMessage("[ShaderMod] Holy Shit!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
	       else
		     if ((CritCombo > 13 and CritCombo < 16)) then
				SendChatMessage("[ShaderMod] Whicked Sick!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
		  else
			if ((CritCombo > 11 and CritCombo < 14)) then
				SendChatMessage("[ShaderMod] God Like!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
		     else
			    if ((CritCombo > 9 and CritCombo < 12)) then
				    SendChatMessage("[ShaderMod] Ultra Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
			 else
				if ((CritCombo > 7 and CritCombo < 10)) then
					SendChatMessage("[ShaderMod] Rampage!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
			     else
					if ((CritCombo > 6 and CritCombo < 8)) then
						SendChatMessage("[ShaderMod] Dominating!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
			           else
						if ((CritCombo > 5 and CritCombo < 7)) then
							SendChatMessage("[ShaderMod] Killing Spree!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "PARTY");
						end

					   end
				      end
			          end
		             end
	                 end
                     end
                end
           end
      end
 end


-- RAID DISPLAY **
	if (SMData[SMPlayerRealm][SMPlayerName].Raid_Display == true) then
             if ((CritCombo > 22)) then
		SendChatMessage("[ShaderMod] Ownnnaaaaaggge!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
         else
               if ((CritCombo > 18 and CritCombo < 21)) then
			SendChatMessage("[ShaderMod] Lu-lu-lu-lu-ludicrous Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
	   else
        	 if ((CritCombo > 16 and CritCombo < 19)) then
				SendChatMessage("[ShaderMod] Mm-Mmm Monster Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
	     else
        	   if ((CritCombo > 15 and CritCombo < 17)) then
				SendChatMessage("[ShaderMod] Holy Shit!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
	       else
		     if ((CritCombo > 13 and CritCombo < 16)) then
				SendChatMessage("[ShaderMod] Whicked Sick!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
		  else
			if ((CritCombo > 11 and CritCombo < 14)) then
				SendChatMessage("[ShaderMod] God Like!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
		     else
			    if ((CritCombo > 9 and CritCombo < 12)) then
				    SendChatMessage("[ShaderMod] Ultra Kill!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
			 else
				if ((CritCombo > 7 and CritCombo < 10)) then
					SendChatMessage("[ShaderMod] Rampage!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
			     else
					if ((CritCombo > 6 and CritCombo < 8)) then
						SendChatMessage("[ShaderMod] Dominating!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
			           else
						if ((CritCombo > 5 and CritCombo < 7)) then
							SendChatMessage("[ShaderMod] Killing Spree!  *" .. CritCombo .. "* crits for *" .. CritComboDmg .. "* damage! ", "RAID");
						end

					   end
				      end
			          end
		             end
	                 end
                     end
                end
           end
      end
 end
	
	-- Crit Varibles reset.
	CritCombo = 0;
	CritComboDmg = 0;
end


-- Function: 		SMInitializeSMData()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Initializes SMData incase it isn't already in SavedVariables
function SMInitializeSMData()
	if (SMData == nil) then
		SMData = {};
	end
	
	if (SMData[SMPlayerRealm] == nil) then
		SMData[SMPlayerRealm] = {};
	end

	if (SMPlayerName ~= nil and SMPlayerName ~= UNKNOWNOBJECT and SMPlayerName ~= UKNOWNBEING) then
		if (SMData[SMPlayerRealm][SMPlayerName] == nil) then
			SMData[SMPlayerRealm][SMPlayerName] = {};
			SMSetCurrentPlayerToZeros();
			SMSetDefaultOptions();
		end
	end
end


-- Function: 		SMSetCurrentPlayerToZeros()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Sets all the records to be 0 hits with 0 damage
function SMSetCurrentPlayerToZeros()
	SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritCombo = 0;
	SMData[SMPlayerRealm][SMPlayerName].RecordHitsCritComboDmg = 0;
	SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritCombo = 0;
	SMData[SMPlayerRealm][SMPlayerName].RecordDmgCritComboDmg = 0;
end


-- Function: 		SMSetDefaultOptions()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Sets all the records to be 0 hits with 0 damage
function SMSetDefaultOptions()
	SMData[SMPlayerRealm][SMPlayerName].Misses_Break_Combo = true;
	SMData[SMPlayerRealm][SMPlayerName].Combos_End_After_Battle = true;
	SMData[SMPlayerRealm][SMPlayerName].Party_Display = false;
	SMData[SMPlayerRealm][SMPlayerName].Raid_Display = false;
	SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display = true;
	SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big = true;
	SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Small = true;
end

-- Function: 		SMResetAll()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Used when clicking Reset All in the options menu. Deletes all options and records
function SMResetAll()
	SMData = {};
	SMInitializeSMData();
	SMOptionsFrame_OnShow();
		
	DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] All records and options reset.", .2, .0);
end


-- Function: 		SMDisplayHelp()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Outputs Help menu to DEFAULT_CHAT_FRAME
function SMDisplayHelp()
	DEFAULT_CHAT_FRAME:AddMessage("[ShaderMod] " .. SHADERMOD_VERSION .. " - Modification of CritCombo by Kuipo.", .2, .0);
	DEFAULT_CHAT_FRAME:AddMessage("[Commands] (/ShaderMod, /ShaderM, /sm)",.65,.65,.6);
	DEFAULT_CHAT_FRAME:AddMessage("   menu - Shows the options menu.");
	DEFAULT_CHAT_FRAME:AddMessage("   records - Shows your records.");
	DEFAULT_CHAT_FRAME:AddMessage("   version - Displays current version.");
end



-- Function: 		SMOptionsFrame_OnShow()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Populates checkboxes of options panel when it is opened
function SMOptionsFrame_OnShow()	
	if (SMData[SMPlayerRealm][SMPlayerName].Running_Combo_Display) then
		SMCheckBoxRunning_Combo_Display:SetChecked(1);
	else
		SMCheckBoxRunning_Combo_Display:SetChecked(0);
	end

	if (SMData[SMPlayerRealm][SMPlayerName].Party_Display) then
		SMCheckBoxParty_Display:SetChecked(1);
	else
		SMCheckBoxParty_Display:SetChecked(0);
	end

	if (SMData[SMPlayerRealm][SMPlayerName].Raid_Display) then
		SMCheckBoxRaid_Display:SetChecked(1);
	else
		SMCheckBoxRaid_Display:SetChecked(0);
	end

	if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Big) then
		SMCheckBoxEnable_Sound_Big:SetChecked(1);
	else
		SMCheckBoxEnable_Sound_Big:SetChecked(0);
	end

	if (SMData[SMPlayerRealm][SMPlayerName].Enable_Sound_Small) then
		SMCheckBoxEnable_Sound_Small:SetChecked(1);
	else
		SMCheckBoxEnable_Sound_Small:SetChecked(0);
	end
	
end


-- Function: 		SMCheckBoxClick()
-- Arguments:		var_to_toggle == variable that will be toggled from either true to false
-- Returns:  		None
-- Used for: 		Populates checkboxes of options panel when it is opened
function SMCheckBoxClick(var_to_toggle)
	if ( this:GetChecked() ) then
		var_to_toggle = true;
	else
		var_to_toggle = false;
	end
end


